--- old/usr/src/lib/pkcs11/libpkcs11/common/metaObjectManager.c	Fri Jul  6 15:55:04 2018
+++ new/usr/src/lib/pkcs11/libpkcs11/common/metaObjectManager.c	Fri Jul  6 15:55:04 2018
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2004, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2018, Joyent, Inc.
  */
 
 
@@ -596,7 +597,8 @@
 
 	if (object->clone_template) {
 		for (i = 0; i < object->clone_template_size; i++) {
-			free(((object->clone_template)[i]).pValue);
+			freezero((object->clone_template)[i].pValue,
+			    (object->clone_template)[i].ulValueLen);
 		}
 		free(object->clone_template);
 	}
@@ -859,7 +861,8 @@
 	if (attrs_with_val) {
 		for (i = 0; i < num_attrs; i++) {
 			if (attrs_with_val[i].pValue != NULL) {
-				free(attrs_with_val[i].pValue);
+				freezero(attrs_with_val[i].pValue,
+				    attrs_with_val[i].ulValueLen);
 			}
 		}
 		free(attrs_with_val);
@@ -1491,7 +1494,7 @@
 	}
 
 	if (wrappedKey) {
-		free(wrappedKey);
+		freezero(wrappedKey, wrappedKeyLen);
 	}
 
 	if (src_slot_session) {
